Index: branches/network/src/lib/network/message_manager.cc
===================================================================
--- branches/network/src/lib/network/message_manager.cc	(revision 8642)
+++ branches/network/src/lib/network/message_manager.cc	(revision 8643)
@@ -19,4 +19,5 @@
 
 #include "network_stream.h"
+#include "shared_network_data.h"
 
 using namespace std;
@@ -339,5 +340,5 @@
     msg.length = dataLength;
     msg.messageId = messageId;
-    msg.number = newNumber++;
+    msg.number = SharedNetworkData::getInstance()->getHostID();
     msg.priority = messagePriority;
 
Index: branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- branches/network/src/lib/network/network_game_manager.cc	(revision 8642)
+++ branches/network/src/lib/network/network_game_manager.cc	(revision 8643)
@@ -112,5 +112,5 @@
   stats->setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
   stats->setSynchronized( true );
-  stats->setOwner( getHostID() );
+  stats->setOwner( SharedNetworkData::getInstance()->getHostID() );
   
   stats->setTeamId( team );
@@ -247,5 +247,5 @@
 {
   if ( isServer() )
-    setPreferedTeam( getHostID(), teamId );
+    setPreferedTeam( SharedNetworkData::getInstance()->getHostID(), teamId );
   else
   {
@@ -284,4 +284,10 @@
 bool NetworkGameManager::chatMessageHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
+  PRINTF(0)("NetworkGameManager::chatMessageHandler %d %d\n", userId, SharedNetworkData::getInstance()->getHostID() );
+  if ( NetworkGameManager::getInstance()->isServer() && userId !=  SharedNetworkData::getInstance()->getHostID() )
+  {
+    MessageManager::getInstance()->sendMessage( messageId, data, dataLength, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+  }
+  
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
@@ -289,5 +295,5 @@
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
   
-  if ( dataLength < 2*INTSIZE )
+  if ( dataLength < 3*INTSIZE )
   {
     PRINTF(2)("got too small chatmessage from client %d\n", userId);
@@ -298,8 +304,10 @@
   int messageType = 0;
   Converter::byteArrayToInt( data, &messageType );
+  int senderUserId = 0;
+  Converter::byteArrayToInt( data+INTSIZE, &senderUserId );
   std::string message;
-  Converter::byteArrayToString( data+INTSIZE, message, dataLength-INTSIZE );
-  
-  rules.handleChatMessage( userId, message, messageType );
+  Converter::byteArrayToString( data+2*INTSIZE, message, dataLength-2*INTSIZE );
+  
+  rules.handleChatMessage( senderUserId, message, messageType );
 
   return true;
@@ -310,17 +318,18 @@
  * @param message message text
  * @param messageType some int
- * @param userId user to send message to -1 = ALL
- */
-void NetworkGameManager::sendChatMessage( const std::string & message, int messageType, int userId )
-{
-  byte * buf = new byte[message.length()+2*INTSIZE];
+ */
+void NetworkGameManager::sendChatMessage( const std::string & message, int messageType )
+{
+  byte * buf = new byte[message.length()+3*INTSIZE];
 
   assert( Converter::intToByteArray( messageType, buf, INTSIZE ) == INTSIZE );
-  assert( Converter::stringToByteArray(message, buf+INTSIZE, message.length()+INTSIZE) == message.length()+INTSIZE );
-  
-  if ( userId == -1 )
-    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+2*INTSIZE, RT_ALL_ME, 0, MP_HIGHBANDWIDTH );
+  assert( Converter::intToByteArray( SharedNetworkData::getInstance()->getHostID(), buf+INTSIZE, INTSIZE ) == INTSIZE );
+  assert( Converter::stringToByteArray(message, buf+2*INTSIZE, message.length()+INTSIZE) == message.length()+INTSIZE );
+  
+  if ( this->isServer() )
+    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_ME, 0, MP_HIGHBANDWIDTH );
   else
-    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+2*INTSIZE, RT_USER, userId, MP_HIGHBANDWIDTH );
+    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+
   
   delete [] buf;
Index: branches/network/src/lib/network/network_game_manager.h
===================================================================
--- branches/network/src/lib/network/network_game_manager.h	(revision 8642)
+++ branches/network/src/lib/network/network_game_manager.h	(revision 8643)
@@ -65,5 +65,5 @@
     void tick( float ds );
     
-    void sendChatMessage( const std::string & message, int messageType, int userId = -1 );
+    void sendChatMessage( const std::string & message, int messageType );
 
   private:
Index: branches/network/src/lib/network/player_stats.cc
===================================================================
--- branches/network/src/lib/network/player_stats.cc	(revision 8642)
+++ branches/network/src/lib/network/player_stats.cc	(revision 8643)
@@ -95,5 +95,5 @@
     this->setPlayableUniqueId( this->playableUniqueId );
     
-    PRINTF(0)("uniqueID changed %d %d %d\n", userId, getHostID(), getUniqueID());
+    PRINTF(0)("uniqueID changed %d %d %d\n", userId, SharedNetworkData::getInstance()->getHostID(), getUniqueID());
   }
   
@@ -155,5 +155,5 @@
   }
   
-  if ( this->playable && userId == getHostID() )
+  if ( this->playable && userId == SharedNetworkData::getInstance()->getHostID() )
   {
     State::getPlayer()->setPlayable( this->playable );
Index: branches/network/src/lib/network/synchronizeable.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable.cc	(revision 8642)
+++ branches/network/src/lib/network/synchronizeable.cc	(revision 8643)
@@ -38,6 +38,5 @@
   this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
   this->owner = 0;
-  this->hostID = SharedNetworkData::getInstance()->getHostID();
-  this->setIsServer(this->hostID == 0);
+  this->setIsServer(SharedNetworkData::getInstance()->getHostID() == 0);
   this->uniqueID = NET_UID_UNASSIGNED;
   this->networkStream = NULL;
@@ -222,5 +221,5 @@
     hasPermission = (
             this->isServer() && (*it)->checkPermission( PERMISSION_SERVER ) ||
-            this->owner == this->hostID && (*it)->checkPermission( PERMISSION_OWNER ) ||
+        this->owner == SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ) ||
             this->isServer() && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ) ||
             (*it)->checkPermission( PERMISSION_ALL ) 
@@ -345,5 +344,5 @@
         (*it)->checkPermission( PERMISSION_SERVER ) && networkStream->isUserServer( userId ) ||
         (*it)->checkPermission( PERMISSION_OWNER ) && this->owner == userId ||
-        networkStream->isUserServer( userId ) && this->owner != getHostID() && (*it)->checkPermission( PERMISSION_OWNER ) ||
+        networkStream->isUserServer( userId ) && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ) ||
         (*it)->checkPermission( PERMISSION_ALL ) 
        )
Index: branches/network/src/lib/network/synchronizeable.h
===================================================================
--- branches/network/src/lib/network/synchronizeable.h	(revision 8642)
+++ branches/network/src/lib/network/synchronizeable.h	(revision 8643)
@@ -67,5 +67,4 @@
     inline void setUniqueID( int id ){ uniqueID = id; }
     inline int  getUniqueID() const { return uniqueID; }
-    inline int getHostID() { return this->hostID; }
 
     inline int getOwner(){ return owner; }
@@ -89,5 +88,4 @@
     int               mLeafClassId;   //!< store leafClassId to send via states
     int               owner;          //!< hostId of owner ( 0 if none / server )
-    int               hostID;         //!< my own host id
     bool              bSynchronize;   //!< do we need beeing synchronized?
 
Index: branches/network/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- branches/network/src/util/multiplayer_team_deathmatch.cc	(revision 8642)
+++ branches/network/src/util/multiplayer_team_deathmatch.cc	(revision 8643)
@@ -87,5 +87,8 @@
   this->notifier->show();
   this->notifier->setAbsCoor2D(5, 30);
+  this->notifier->setFadeAge( 6.0 );
+  this->notifier->setHideAge( 8.0 );
   this->input = new OrxGui::GLGuiInputLine();
+  this->input->setAbsCoor2D(180, 5);
   this->input->connect(SIGNAL(input, enterPushed), this, SLOT(MultiplayerTeamDeathmatch, onInputEnter));
 }
@@ -597,5 +600,5 @@
   }
   
-  PRINTF(0)("CHATMESSAGE %s: %s\n", name.c_str(), message.c_str() );
+  PRINTF(0)("CHATMESSAGE %s (%d): %s\n", name.c_str(), userId, message.c_str() );
   notifier->pushNotifyMessage(name + ": " + message);
 }
Index: branches/network/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/network/src/world_entities/space_ships/space_ship.cc	(revision 8642)
+++ branches/network/src/world_entities/space_ships/space_ship.cc	(revision 8643)
@@ -33,4 +33,5 @@
 
 #include "network_game_manager.h"
+#include "shared_network_data.h"
 
 #include "power_ups/weapon_power_up.h"
@@ -326,5 +327,5 @@
   Playable::tick(time);
 
-  if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == this->getHostID() )
+  if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == SharedNetworkData::getInstance()->getHostID() )
    {
     if (xMouse > controlVelocityX) xMouse = controlVelocityX;
Index: branches/network/src/world_entities/spectator.cc
===================================================================
--- branches/network/src/world_entities/spectator.cc	(revision 8642)
+++ branches/network/src/world_entities/spectator.cc	(revision 8643)
@@ -20,4 +20,5 @@
 #include "key_mapper.h"
 
+#include "shared_network_data.h"
 
 CREATE_FACTORY(Spectator, CL_SPECTATOR);
@@ -161,5 +162,5 @@
   Playable::tick( time );
   
-  if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == this->getHostID() )
+  if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == SharedNetworkData::getInstance()->getHostID() )
   {
     xMouse *= time / 10;