Index: code/branches/presentation/src/modules/notifications/NotificationQueue.cc
===================================================================
--- code/branches/presentation/src/modules/notifications/NotificationQueue.cc	(revision 8650)
+++ code/branches/presentation/src/modules/notifications/NotificationQueue.cc	(revision 8651)
@@ -52,9 +52,10 @@
         The creator of the NotificationQueue.
     */
-    NotificationQueue::NotificationQueue(BaseObject* creator) : BaseObject(creator), registered_(false)
+    NotificationQueue::NotificationQueue(BaseObject* creator) : BaseObject(creator), Synchronisable(creator), registered_(false)
     {
         RegisterObject(NotificationQueue);
 
         this->initialize();
+        this->registerVariables();
     }
 
@@ -161,4 +162,18 @@
         this->create();
     }
+    
+    
+    /**
+    @brief
+        Registers Variables to be Synchronised.
+        Registers Variables which have to be synchronised to the network system.
+      */
+    void NotificationQueue::registerVariables()
+    {
+        registerVariable( this->maxSize_, VariableDirection::ToClient );
+        registerVariable( this->targets_, VariableDirection::ToClient );
+        registerVariable( this->displayTime_, VariableDirection::ToClient );
+    }
+
 
     /**
Index: code/branches/presentation/src/modules/notifications/NotificationQueue.h
===================================================================
--- code/branches/presentation/src/modules/notifications/NotificationQueue.h	(revision 8650)
+++ code/branches/presentation/src/modules/notifications/NotificationQueue.h	(revision 8651)
@@ -47,4 +47,5 @@
 #include "core/BaseObject.h"
 #include "tools/interfaces/Tickable.h"
+#include "network/synchronisable/Synchronisable.h"
 
 namespace orxonox
@@ -89,5 +90,5 @@
     @ingroup Notifications
     */
-    class _NotificationsExport NotificationQueue : public BaseObject, public Tickable
+    class _NotificationsExport NotificationQueue : public BaseObject, public Tickable, public Synchronisable
     {
 
@@ -99,5 +100,6 @@
             virtual void tick(float dt); // To update from time to time.
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-
+            void registerVariables();
+            
             void update(void); // Updates the NotificationQueue.
             void update(Notification* notification, const std::time_t & time); // Updates the NotificationQueue by adding an new Notification.
Index: code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.cc
===================================================================
--- code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.cc	(revision 8650)
+++ code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.cc	(revision 8651)
@@ -59,4 +59,5 @@
 
         this->initialize();
+        this->registerVariables();
     }
     
@@ -90,4 +91,13 @@
         XMLPortParam(NotificationQueueCEGUI, "alignment", setAlignment, getAlignment, xmlelement, mode);
         XMLPortParam(NotificationQueueCEGUI, "displaySize", setDisplaySize, getDisplaySize, xmlelement, mode);
+    }
+    
+    void NotificationQueueCEGUI::registerVariables()
+    {
+        registerVariable( this->position_, VariableDirection::ToClient );
+        registerVariable( this->fontSize_, VariableDirection::ToClient );
+        registerVariable( this->fontColor_, VariableDirection::ToClient );
+        registerVariable( this->alignment_, VariableDirection::ToClient );
+        registerVariable( this->displaySize_, VariableDirection::ToClient );
     }
 
Index: code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.h
===================================================================
--- code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.h	(revision 8650)
+++ code/branches/presentation/src/modules/notifications/NotificationQueueCEGUI.h	(revision 8651)
@@ -74,4 +74,5 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            void registerVariables();
 
             void destroy(bool noGraphics = false); // Destroys the NotificationQueue.
Index: code/branches/presentation/src/orxonox/worldentities/pawns/SpaceShip.cc
===================================================================
--- code/branches/presentation/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8650)
+++ code/branches/presentation/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8651)
@@ -118,7 +118,7 @@
         XMLPortParamVariable(SpaceShip, "boostRate", boostRate_, xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "boostCooldownDuration", boostCooldownDuration_, xmlelement, mode);
-		XMLPortParamVariable(SpaceShip, "shakeFrequency", shakeFrequency_, xmlelement, mode);
+        XMLPortParamVariable(SpaceShip, "shakeFrequency", shakeFrequency_, xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "shakeAmplitude", shakeAmplitude_, xmlelement, mode);
-		XMLPortParamVariable(SpaceShip, "lift", lift_, xmlelement, mode);
+        XMLPortParamVariable(SpaceShip, "lift", lift_, xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "stallSpeed", stallSpeed_, xmlelement, mode);
 