Index: branches/gui/src/lib/gui/gl/glgui_handler.cc
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_handler.cc	(revision 8651)
+++ branches/gui/src/lib/gui/gl/glgui_handler.cc	(revision 8652)
@@ -104,20 +104,20 @@
     {
       case  EV_MOUSE_BUTTON_LEFT:
-        if (GLGuiWidget::focused() != NULL)
+        if (GLGuiWidget::mouseFocused() != NULL)
         {
           if (event.bPressed)
           {
-            if (GLGuiWidget::focused()->clickable())
+            if (GLGuiWidget::mouseFocused()->clickable())
             {
               Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
-              GLGuiWidget::focused()->click(cursorPos - GLGuiWidget::focused()->getAbsCoor2D());
+              GLGuiWidget::mouseFocused()->click(cursorPos - GLGuiWidget::mouseFocused()->getAbsCoor2D());
             }
           }
           else
           {
-            if (GLGuiWidget::focused()->clickable())
+            if (GLGuiWidget::mouseFocused()->clickable())
             {
               Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
-              GLGuiWidget::focused()->release(cursorPos - GLGuiWidget::focused()->getAbsCoor2D());
+              GLGuiWidget::mouseFocused()->release(cursorPos - GLGuiWidget::mouseFocused()->getAbsCoor2D());
             }
           }
@@ -125,6 +125,6 @@
         break;
       case EV_LEAVE_STATE:
-        if (GLGuiWidget::focused() != NULL)
-          GLGuiWidget::focused()->breakFocus();
+        if (GLGuiWidget::mouseFocused() != NULL)
+          GLGuiWidget::mouseFocused()->breakMouseFocus();
         break;
 
@@ -137,7 +137,7 @@
 
 
-    if (GLGuiWidget::focused())
-    {
-      GLGuiWidget::focused()->processEvent(event);
+    if (GLGuiWidget::mouseFocused())
+    {
+      GLGuiWidget::mouseFocused()->processEvent(event);
     }
 
@@ -192,13 +192,13 @@
         {
           // receiving Focus
-          if (GLGuiWidget::focused() != widget)
+          if (GLGuiWidget::mouseFocused() != widget)
           {
-            widget->giveFocus();
+            widget->giveMouseFocus();
           }
           return ;
         }
       }
-      if (GLGuiWidget::focused() != NULL)
-        GLGuiWidget::focused()->breakFocus();
+      if (GLGuiWidget::mouseFocused() != NULL)
+        GLGuiWidget::mouseFocused()->breakMouseFocus();
     }
   }
Index: branches/gui/src/lib/gui/gl/glgui_table.cc
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_table.cc	(revision 8651)
+++ branches/gui/src/lib/gui/gl/glgui_table.cc	(revision 8652)
@@ -264,4 +264,6 @@
 
     glEnd();
+
+
 
     this->endDraw();
Index: branches/gui/src/lib/gui/gl/glgui_widget.cc
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_widget.cc	(revision 8651)
+++ branches/gui/src/lib/gui/gl/glgui_widget.cc	(revision 8652)
@@ -72,10 +72,10 @@
   GLGuiWidget::~GLGuiWidget()
   {
-    if (this == GLGuiWidget::_focused)
-      GLGuiWidget::_focused = NULL;
+    if (this == GLGuiWidget::_mouseFocused)
+      GLGuiWidget::_mouseFocused = NULL;
   }
 
   GLGuiWidget* GLGuiWidget::_selected = NULL;
-  GLGuiWidget* GLGuiWidget::_focused = NULL;
+  GLGuiWidget* GLGuiWidget::_mouseFocused = NULL;
   GLGuiWidget* GLGuiWidget::_inputGrabber = NULL;
 
@@ -134,17 +134,17 @@
 
   /** @brief gives focus to this widget */
-  void GLGuiWidget::giveFocus()
-  {
-    if (GLGuiWidget::focused() != NULL)
-      GLGuiWidget::focused()->breakFocus();
-    GLGuiWidget::_focused = this;
+  void GLGuiWidget::giveMouseFocus()
+  {
+    if (GLGuiWidget::mouseFocused() != NULL)
+      GLGuiWidget::mouseFocused()->breakMouseFocus();
+    GLGuiWidget::_mouseFocused = this;
     this->receivedFocus();
   };
 
-  void GLGuiWidget::breakFocus()
-  {
-    if (GLGuiWidget::_focused == this)
+  void GLGuiWidget::breakMouseFocus()
+  {
+    if (GLGuiWidget::_mouseFocused == this)
     {
-      GLGuiWidget::_focused = NULL;
+      GLGuiWidget::_mouseFocused = NULL;
       this->_pushed = false;
       this->removedFocus();
Index: branches/gui/src/lib/gui/gl/glgui_widget.h
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_widget.h	(revision 8651)
+++ branches/gui/src/lib/gui/gl/glgui_widget.h	(revision 8652)
@@ -43,6 +43,6 @@
     /// FOCUS
     /** @brief gives focus to this widget */
-    void giveFocus();
-    void breakFocus();
+    void giveMouseFocus();
+    void breakMouseFocus();
     /** @returns true if the widget is focusable */
     bool focusable() const { return this->_focusable; };
@@ -55,5 +55,5 @@
 
     /** @returns the currently focused Widget (NULL if none is selected) */
-    static GLGuiWidget* focused() { return GLGuiWidget::_focused; };
+    static GLGuiWidget* mouseFocused() { return GLGuiWidget::_mouseFocused; };
 
 
@@ -251,5 +251,5 @@
   private:
     static GLGuiWidget*            _selected;         //!< The currently selected Widget.
-    static GLGuiWidget*            _focused;          //!< The currently Focused Widget (mouse-focus).
+    static GLGuiWidget*            _mouseFocused;     //!< The currently Focused Widget (mouse-focus).
     static GLGuiWidget*            _inputGrabber;     //!< The Widget that grabs input (keyboard-focus).
 